#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 245
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 128
#define ALIAS_COUNT 0
#define TOKEN_COUNT 67
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 57

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_return = 3,
  anon_sym_SEMI = 4,
  anon_sym_EQ = 5,
  anon_sym_COMMA = 6,
  anon_sym_COLON_COLON = 7,
  sym_break_statement = 8,
  anon_sym_goto = 9,
  anon_sym_do = 10,
  anon_sym_end = 11,
  anon_sym_while = 12,
  anon_sym_repeat = 13,
  anon_sym_until = 14,
  anon_sym_if = 15,
  anon_sym_then = 16,
  anon_sym_elseif = 17,
  anon_sym_else = 18,
  anon_sym_for = 19,
  anon_sym_in = 20,
  anon_sym_function = 21,
  anon_sym_local = 22,
  anon_sym_DOT = 23,
  anon_sym_COLON = 24,
  anon_sym_LT = 25,
  anon_sym_GT = 26,
  sym_nil = 27,
  sym_false = 28,
  sym_true = 29,
  sym_number = 30,
  sym_vararg_expression = 31,
  anon_sym_LPAREN = 32,
  anon_sym_RPAREN = 33,
  anon_sym_LBRACK = 34,
  anon_sym_RBRACK = 35,
  anon_sym_LBRACE = 36,
  anon_sym_RBRACE = 37,
  anon_sym_or = 38,
  anon_sym_and = 39,
  anon_sym_LT_EQ = 40,
  anon_sym_EQ_EQ = 41,
  anon_sym_TILDE_EQ = 42,
  anon_sym_GT_EQ = 43,
  anon_sym_PIPE = 44,
  anon_sym_TILDE = 45,
  anon_sym_AMP = 46,
  anon_sym_LT_LT = 47,
  anon_sym_GT_GT = 48,
  anon_sym_PLUS = 49,
  anon_sym_DASH = 50,
  anon_sym_STAR = 51,
  anon_sym_SLASH = 52,
  anon_sym_SLASH_SLASH = 53,
  anon_sym_PERCENT = 54,
  anon_sym_DOT_DOT = 55,
  anon_sym_CARET = 56,
  anon_sym_not = 57,
  anon_sym_POUND = 58,
  anon_sym_DASH_DASH = 59,
  aux_sym_comment_token1 = 60,
  sym__block_comment_start = 61,
  sym__block_comment_content = 62,
  sym__block_comment_end = 63,
  sym__string_start = 64,
  sym__string_content = 65,
  sym__string_end = 66,
  sym_chunk = 67,
  sym__block = 68,
  sym_statement = 69,
  sym_return_statement = 70,
  sym_empty_statement = 71,
  sym_assignment_statement = 72,
  sym__variable_assignment_varlist = 73,
  sym__variable_assignment_explist = 74,
  sym_label_statement = 75,
  sym_goto_statement = 76,
  sym_do_statement = 77,
  sym_while_statement = 78,
  sym_repeat_statement = 79,
  sym_if_statement = 80,
  sym_elseif_statement = 81,
  sym_else_statement = 82,
  sym_for_statement = 83,
  sym_for_generic_clause = 84,
  sym_for_numeric_clause = 85,
  sym_declaration = 86,
  sym_function_declaration = 87,
  sym__local_function_declaration = 88,
  sym__function_name = 89,
  sym__function_name_prefix_expression = 90,
  sym__function_name_dot_index_expression = 91,
  sym__function_name_method_index_expression = 92,
  sym_variable_declaration = 93,
  sym__local_variable_assignment = 94,
  sym__name_list = 95,
  sym__att_name_list = 96,
  sym__attrib = 97,
  sym__expression_list = 98,
  sym_expression = 99,
  sym_string = 100,
  sym_function_definition = 101,
  sym__function_body = 102,
  sym_parameters = 103,
  sym__parameter_list = 104,
  sym__prefix_expression = 105,
  sym_variable = 106,
  sym_bracket_index_expression = 107,
  sym_dot_index_expression = 108,
  sym_function_call = 109,
  sym_method_index_expression = 110,
  sym_arguments = 111,
  sym_parenthesized_expression = 112,
  sym_table_constructor = 113,
  sym__field_list = 114,
  sym__field_sep = 115,
  sym_field = 116,
  sym_binary_expression = 117,
  sym_unary_expression = 118,
  sym_comment = 119,
  aux_sym_chunk_repeat1 = 120,
  aux_sym__variable_assignment_varlist_repeat1 = 121,
  aux_sym__variable_assignment_explist_repeat1 = 122,
  aux_sym_if_statement_repeat1 = 123,
  aux_sym__name_list_repeat1 = 124,
  aux_sym__att_name_list_repeat1 = 125,
  aux_sym__expression_list_repeat1 = 126,
  aux_sym__field_list_repeat1 = 127,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_return] = "return",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [sym_break_statement] = "break_statement",
  [anon_sym_goto] = "goto",
  [anon_sym_do] = "do",
  [anon_sym_end] = "end",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_until] = "until",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_function] = "function",
  [anon_sym_local] = "local",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON] = ":",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [sym_nil] = "nil",
  [sym_false] = "false",
  [sym_true] = "true",
  [sym_number] = "number",
  [sym_vararg_expression] = "vararg_expression",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PIPE] = "|",
  [anon_sym_TILDE] = "~",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_CARET] = "^",
  [anon_sym_not] = "not",
  [anon_sym_POUND] = "#",
  [anon_sym_DASH_DASH] = "comment_start",
  [aux_sym_comment_token1] = "comment_content",
  [sym__block_comment_start] = "comment_start",
  [sym__block_comment_content] = "comment_content",
  [sym__block_comment_end] = "comment_end",
  [sym__string_start] = "string_start",
  [sym__string_content] = "string_content",
  [sym__string_end] = "string_end",
  [sym_chunk] = "chunk",
  [sym__block] = "block",
  [sym_statement] = "statement",
  [sym_return_statement] = "return_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym__variable_assignment_varlist] = "variable_list",
  [sym__variable_assignment_explist] = "expression_list",
  [sym_label_statement] = "label_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_do_statement] = "do_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_statement] = "elseif_statement",
  [sym_else_statement] = "else_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_generic_clause] = "for_generic_clause",
  [sym_for_numeric_clause] = "for_numeric_clause",
  [sym_declaration] = "declaration",
  [sym_function_declaration] = "function_declaration",
  [sym__local_function_declaration] = "function_declaration",
  [sym__function_name] = "_function_name",
  [sym__function_name_prefix_expression] = "_function_name_prefix_expression",
  [sym__function_name_dot_index_expression] = "dot_index_expression",
  [sym__function_name_method_index_expression] = "method_index_expression",
  [sym_variable_declaration] = "variable_declaration",
  [sym__local_variable_assignment] = "assignment_statement",
  [sym__name_list] = "variable_list",
  [sym__att_name_list] = "variable_list",
  [sym__attrib] = "attribute",
  [sym__expression_list] = "expression_list",
  [sym_expression] = "expression",
  [sym_string] = "string",
  [sym_function_definition] = "function_definition",
  [sym__function_body] = "_function_body",
  [sym_parameters] = "parameters",
  [sym__parameter_list] = "_parameter_list",
  [sym__prefix_expression] = "_prefix_expression",
  [sym_variable] = "variable",
  [sym_bracket_index_expression] = "bracket_index_expression",
  [sym_dot_index_expression] = "dot_index_expression",
  [sym_function_call] = "function_call",
  [sym_method_index_expression] = "method_index_expression",
  [sym_arguments] = "arguments",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_table_constructor] = "table_constructor",
  [sym__field_list] = "_field_list",
  [sym__field_sep] = "_field_sep",
  [sym_field] = "field",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_comment] = "comment",
  [aux_sym_chunk_repeat1] = "chunk_repeat1",
  [aux_sym__variable_assignment_varlist_repeat1] = "_variable_assignment_varlist_repeat1",
  [aux_sym__variable_assignment_explist_repeat1] = "_variable_assignment_explist_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym__name_list_repeat1] = "_name_list_repeat1",
  [aux_sym__att_name_list_repeat1] = "_att_name_list_repeat1",
  [aux_sym__expression_list_repeat1] = "_expression_list_repeat1",
  [aux_sym__field_list_repeat1] = "_field_list_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [sym_break_statement] = sym_break_statement,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [sym_nil] = sym_nil,
  [sym_false] = sym_false,
  [sym_true] = sym_true,
  [sym_number] = sym_number,
  [sym_vararg_expression] = sym_vararg_expression,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DASH_DASH] = sym__block_comment_start,
  [aux_sym_comment_token1] = sym__block_comment_content,
  [sym__block_comment_start] = sym__block_comment_start,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__block_comment_end] = sym__block_comment_end,
  [sym__string_start] = sym__string_start,
  [sym__string_content] = sym__string_content,
  [sym__string_end] = sym__string_end,
  [sym_chunk] = sym_chunk,
  [sym__block] = sym__block,
  [sym_statement] = sym_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym__variable_assignment_varlist] = sym__variable_assignment_varlist,
  [sym__variable_assignment_explist] = sym__variable_assignment_explist,
  [sym_label_statement] = sym_label_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_statement] = sym_elseif_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_generic_clause] = sym_for_generic_clause,
  [sym_for_numeric_clause] = sym_for_numeric_clause,
  [sym_declaration] = sym_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym__local_function_declaration] = sym_function_declaration,
  [sym__function_name] = sym__function_name,
  [sym__function_name_prefix_expression] = sym__function_name_prefix_expression,
  [sym__function_name_dot_index_expression] = sym_dot_index_expression,
  [sym__function_name_method_index_expression] = sym_method_index_expression,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__local_variable_assignment] = sym_assignment_statement,
  [sym__name_list] = sym__variable_assignment_varlist,
  [sym__att_name_list] = sym__variable_assignment_varlist,
  [sym__attrib] = sym__attrib,
  [sym__expression_list] = sym__variable_assignment_explist,
  [sym_expression] = sym_expression,
  [sym_string] = sym_string,
  [sym_function_definition] = sym_function_definition,
  [sym__function_body] = sym__function_body,
  [sym_parameters] = sym_parameters,
  [sym__parameter_list] = sym__parameter_list,
  [sym__prefix_expression] = sym__prefix_expression,
  [sym_variable] = sym_variable,
  [sym_bracket_index_expression] = sym_bracket_index_expression,
  [sym_dot_index_expression] = sym_dot_index_expression,
  [sym_function_call] = sym_function_call,
  [sym_method_index_expression] = sym_method_index_expression,
  [sym_arguments] = sym_arguments,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_table_constructor] = sym_table_constructor,
  [sym__field_list] = sym__field_list,
  [sym__field_sep] = sym__field_sep,
  [sym_field] = sym_field,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_comment] = sym_comment,
  [aux_sym_chunk_repeat1] = aux_sym_chunk_repeat1,
  [aux_sym__variable_assignment_varlist_repeat1] = aux_sym__variable_assignment_varlist_repeat1,
  [aux_sym__variable_assignment_explist_repeat1] = aux_sym__variable_assignment_explist_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym__name_list_repeat1] = aux_sym__name_list_repeat1,
  [aux_sym__att_name_list_repeat1] = aux_sym__att_name_list_repeat1,
  [aux_sym__expression_list_repeat1] = aux_sym__expression_list_repeat1,
  [aux_sym__field_list_repeat1] = aux_sym__field_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_vararg_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_content] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_end] = {
    .visible = true,
    .named = false,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = true,
    .named = false,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_chunk] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_varlist] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_explist] = {
    .visible = true,
    .named = true,
  },
  [sym_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_generic_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_numeric_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__att_name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__attrib] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracket_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_table_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__field_list] = {
    .visible = false,
    .named = true,
  },
  [sym__field_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_chunk_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_varlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_explist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__att_name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_attribute = 3,
  field_body = 4,
  field_clause = 5,
  field_condition = 6,
  field_consequence = 7,
  field_content = 8,
  field_end = 9,
  field_field = 10,
  field_left = 11,
  field_local_declaration = 12,
  field_method = 13,
  field_name = 14,
  field_operand = 15,
  field_parameters = 16,
  field_right = 17,
  field_start = 18,
  field_step = 19,
  field_table = 20,
  field_value = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_clause] = "clause",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_end] = "end",
  [field_field] = "field",
  [field_left] = "left",
  [field_local_declaration] = "local_declaration",
  [field_method] = "method",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_start] = "start",
  [field_step] = "step",
  [field_table] = "table",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 1},
  [5] = {.index = 7, .length = 2},
  [6] = {.index = 9, .length = 2},
  [7] = {.index = 11, .length = 2},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 2},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 3},
  [13] = {.index = 24, .length = 2},
  [14] = {.index = 26, .length = 1},
  [15] = {.index = 27, .length = 1},
  [16] = {.index = 28, .length = 1},
  [17] = {.index = 29, .length = 1},
  [18] = {.index = 30, .length = 3},
  [19] = {.index = 33, .length = 2},
  [20] = {.index = 35, .length = 3},
  [21] = {.index = 38, .length = 2},
  [22] = {.index = 40, .length = 2},
  [23] = {.index = 42, .length = 2},
  [24] = {.index = 44, .length = 1},
  [25] = {.index = 45, .length = 2},
  [26] = {.index = 47, .length = 1},
  [27] = {.index = 48, .length = 2},
  [28] = {.index = 50, .length = 1},
  [29] = {.index = 51, .length = 2},
  [30] = {.index = 53, .length = 1},
  [31] = {.index = 54, .length = 1},
  [32] = {.index = 55, .length = 1},
  [33] = {.index = 56, .length = 3},
  [34] = {.index = 59, .length = 4},
  [35] = {.index = 63, .length = 4},
  [36] = {.index = 67, .length = 3},
  [37] = {.index = 70, .length = 2},
  [38] = {.index = 72, .length = 1},
  [39] = {.index = 73, .length = 2},
  [40] = {.index = 75, .length = 2},
  [41] = {.index = 77, .length = 2},
  [42] = {.index = 79, .length = 2},
  [43] = {.index = 81, .length = 2},
  [44] = {.index = 83, .length = 2},
  [45] = {.index = 85, .length = 2},
  [46] = {.index = 87, .length = 2},
  [47] = {.index = 89, .length = 2},
  [48] = {.index = 91, .length = 1},
  [49] = {.index = 92, .length = 2},
  [50] = {.index = 94, .length = 3},
  [51] = {.index = 97, .length = 3},
  [52] = {.index = 100, .length = 3},
  [53] = {.index = 103, .length = 3},
  [54] = {.index = 106, .length = 2},
  [55] = {.index = 108, .length = 4},
  [56] = {.index = 112, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_local_declaration, 0, .inherited = true},
  [1] =
    {field_body, 0, .inherited = true},
    {field_local_declaration, 0},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [5] =
    {field_local_declaration, 0},
  [6] =
    {field_name, 0},
  [7] =
    {field_end, 1},
    {field_start, 0},
  [9] =
    {field_content, 1},
    {field_start, 0},
  [11] =
    {field_field, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [13] =
    {field_method, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [15] =
    {field_attribute, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [17] =
    {field_arguments, 1},
    {field_name, 0},
  [19] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [21] =
    {field_content, 1},
    {field_end, 2},
    {field_start, 0},
  [24] =
    {field_body, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [26] =
    {field_value, 0},
  [27] =
    {field_operand, 1},
  [28] =
    {field_body, 1},
  [29] =
    {field_condition, 2},
  [30] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
  [33] =
    {field_attribute, 1},
    {field_name, 0},
  [35] =
    {field_attribute, 1, .inherited = true},
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [38] =
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [40] =
    {field_field, 2},
    {field_table, 0},
  [42] =
    {field_method, 2},
    {field_table, 0},
  [44] =
    {field_name, 1},
  [45] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [47] =
    {field_parameters, 0},
  [48] =
    {field_left, 0},
    {field_right, 2},
  [50] =
    {field_condition, 1},
  [51] =
    {field_body, 1},
    {field_condition, 3},
  [53] =
    {field_alternative, 0},
  [54] =
    {field_clause, 1},
  [55] =
    {field_name, 0, .inherited = true},
  [56] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
  [59] =
    {field_attribute, 1},
    {field_attribute, 2, .inherited = true},
    {field_name, 0},
    {field_name, 2, .inherited = true},
  [63] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [67] =
    {field_attribute, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [70] =
    {field_value, 0},
    {field_value, 1, .inherited = true},
  [72] =
    {field_name, 1, .inherited = true},
  [73] =
    {field_body, 1},
    {field_parameters, 0},
  [75] =
    {field_name, 0},
    {field_value, 2},
  [77] =
    {field_body, 3},
    {field_condition, 1},
  [79] =
    {field_condition, 1},
    {field_consequence, 3},
  [81] =
    {field_alternative, 3},
    {field_condition, 1},
  [83] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 1},
  [85] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [87] =
    {field_body, 3},
    {field_clause, 1},
  [89] =
    {field_attribute, 2},
    {field_name, 1},
  [91] =
    {field_value, 1},
  [92] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [94] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [97] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [100] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_condition, 1},
  [103] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
  [106] =
    {field_name, 1},
    {field_value, 4},
  [108] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [112] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
    {field_step, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 6,
  [32] = 32,
  [33] = 15,
  [34] = 9,
  [35] = 10,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 54,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 53,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 194,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 206,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 208,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(10);
      if (lookahead == '#') ADVANCE(53);
      if (lookahead == '%') ADVANCE(50);
      if (lookahead == '&') ADVANCE(42);
      if (lookahead == '(') ADVANCE(29);
      if (lookahead == ')') ADVANCE(30);
      if (lookahead == '*') ADVANCE(47);
      if (lookahead == '+') ADVANCE(45);
      if (lookahead == ',') ADVANCE(14);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(17);
      if (lookahead == '/') ADVANCE(48);
      if (lookahead == '0') ADVANCE(22);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(12);
      if (lookahead == '<') ADVANCE(19);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(21);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == ']') ADVANCE(32);
      if (lookahead == '^') ADVANCE(52);
      if (lookahead == '{') ADVANCE(33);
      if (lookahead == '|') ADVANCE(39);
      if (lookahead == '}') ADVANCE(34);
      if (lookahead == '~') ADVANCE(41);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(23);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '\\' &&
          (lookahead < 127 || 159 < lookahead)) ADVANCE(54);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(11);
      END_STATE();
    case 2:
      if (lookahead == '.') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(25);
      END_STATE();
    case 3:
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 5:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 6:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 7:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(26);
      END_STATE();
    case 8:
      if (eof) ADVANCE(10);
      if (lookahead == '#') ADVANCE(53);
      if (lookahead == '(') ADVANCE(29);
      if (lookahead == ')') ADVANCE(30);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(2);
      if (lookahead == '0') ADVANCE(22);
      if (lookahead == ';') ADVANCE(12);
      if (lookahead == '>') ADVANCE(20);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '{') ADVANCE(33);
      if (lookahead == '}') ADVANCE(34);
      if (lookahead == '~') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(23);
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '"' &&
          (lookahead < '%' || '=' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          (lookahead < '|' || 159 < lookahead)) ADVANCE(54);
      END_STATE();
    case 9:
      if (eof) ADVANCE(10);
      if (lookahead == '#') ADVANCE(1);
      if (lookahead == '%') ADVANCE(50);
      if (lookahead == '&') ADVANCE(42);
      if (lookahead == '(') ADVANCE(29);
      if (lookahead == ')') ADVANCE(30);
      if (lookahead == '*') ADVANCE(47);
      if (lookahead == '+') ADVANCE(45);
      if (lookahead == ',') ADVANCE(14);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(16);
      if (lookahead == '/') ADVANCE(48);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(12);
      if (lookahead == '<') ADVANCE(19);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(21);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == ']') ADVANCE(32);
      if (lookahead == '^') ADVANCE(52);
      if (lookahead == '{') ADVANCE(33);
      if (lookahead == '|') ADVANCE(39);
      if (lookahead == '}') ADVANCE(34);
      if (lookahead == '~') ADVANCE(41);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '"' &&
          (lookahead < '\'' || '9' < lookahead) &&
          lookahead != '\\' &&
          (lookahead < 127 || 159 < lookahead)) ADVANCE(54);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(11);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(36);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(51);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(25);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(15);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(43);
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(38);
      if (lookahead == '>') ADVANCE(44);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(25);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(4);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(6);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(25);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(23);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(7);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(25);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(26);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_vararg_expression);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '=') ADVANCE(37);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(55);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead != 0 &&
          lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '>' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 159 < lookahead)) ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'd') ADVANCE(3);
      if (lookahead == 'e') ADVANCE(4);
      if (lookahead == 'f') ADVANCE(5);
      if (lookahead == 'g') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(9);
      if (lookahead == 'o') ADVANCE(10);
      if (lookahead == 'r') ADVANCE(11);
      if (lookahead == 't') ADVANCE(12);
      if (lookahead == 'u') ADVANCE(13);
      if (lookahead == 'w') ADVANCE(14);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(15);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(17);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(18);
      if (lookahead == 'n') ADVANCE(19);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      if (lookahead == 'u') ADVANCE(22);
      END_STATE();
    case 6:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(24);
      if (lookahead == 'n') ADVANCE(25);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(27);
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(29);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 12:
      if (lookahead == 'h') ADVANCE(31);
      if (lookahead == 'r') ADVANCE(32);
      END_STATE();
    case 13:
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(34);
      END_STATE();
    case 15:
      if (lookahead == 'd') ADVANCE(35);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 18:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 19:
      if (lookahead == 'd') ADVANCE(38);
      END_STATE();
    case 20:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 21:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(41);
      END_STATE();
    case 23:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 26:
      if (lookahead == 'c') ADVANCE(43);
      END_STATE();
    case 27:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 30:
      if (lookahead == 'p') ADVANCE(46);
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(51);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 36:
      if (lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(54);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(55);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(57);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 48:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(62);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 52:
      if (lookahead == 'k') ADVANCE(64);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(66);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(68);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(69);
      END_STATE();
    case 59:
      if (lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(71);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 65:
      if (lookahead == 'f') ADVANCE(73);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 69:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 74:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 9, .external_lex_state = 2},
  [2] = {.lex_state = 9, .external_lex_state = 3},
  [3] = {.lex_state = 9, .external_lex_state = 3},
  [4] = {.lex_state = 9, .external_lex_state = 3},
  [5] = {.lex_state = 9, .external_lex_state = 3},
  [6] = {.lex_state = 9, .external_lex_state = 3},
  [7] = {.lex_state = 9, .external_lex_state = 3},
  [8] = {.lex_state = 9, .external_lex_state = 3},
  [9] = {.lex_state = 9, .external_lex_state = 3},
  [10] = {.lex_state = 9, .external_lex_state = 3},
  [11] = {.lex_state = 9, .external_lex_state = 3},
  [12] = {.lex_state = 9, .external_lex_state = 3},
  [13] = {.lex_state = 9, .external_lex_state = 3},
  [14] = {.lex_state = 9, .external_lex_state = 3},
  [15] = {.lex_state = 9, .external_lex_state = 3},
  [16] = {.lex_state = 0, .external_lex_state = 2},
  [17] = {.lex_state = 0, .external_lex_state = 2},
  [18] = {.lex_state = 0, .external_lex_state = 2},
  [19] = {.lex_state = 0, .external_lex_state = 2},
  [20] = {.lex_state = 0, .external_lex_state = 2},
  [21] = {.lex_state = 0, .external_lex_state = 2},
  [22] = {.lex_state = 0, .external_lex_state = 2},
  [23] = {.lex_state = 0, .external_lex_state = 2},
  [24] = {.lex_state = 0, .external_lex_state = 2},
  [25] = {.lex_state = 0, .external_lex_state = 2},
  [26] = {.lex_state = 0, .external_lex_state = 2},
  [27] = {.lex_state = 0, .external_lex_state = 2},
  [28] = {.lex_state = 0, .external_lex_state = 2},
  [29] = {.lex_state = 0, .external_lex_state = 2},
  [30] = {.lex_state = 0, .external_lex_state = 2},
  [31] = {.lex_state = 0, .external_lex_state = 2},
  [32] = {.lex_state = 0, .external_lex_state = 2},
  [33] = {.lex_state = 0, .external_lex_state = 2},
  [34] = {.lex_state = 0, .external_lex_state = 2},
  [35] = {.lex_state = 0, .external_lex_state = 2},
  [36] = {.lex_state = 0, .external_lex_state = 2},
  [37] = {.lex_state = 0, .external_lex_state = 2},
  [38] = {.lex_state = 0, .external_lex_state = 2},
  [39] = {.lex_state = 0, .external_lex_state = 2},
  [40] = {.lex_state = 0, .external_lex_state = 2},
  [41] = {.lex_state = 0, .external_lex_state = 2},
  [42] = {.lex_state = 0, .external_lex_state = 2},
  [43] = {.lex_state = 0, .external_lex_state = 2},
  [44] = {.lex_state = 0, .external_lex_state = 2},
  [45] = {.lex_state = 0, .external_lex_state = 2},
  [46] = {.lex_state = 0, .external_lex_state = 2},
  [47] = {.lex_state = 0, .external_lex_state = 2},
  [48] = {.lex_state = 0, .external_lex_state = 2},
  [49] = {.lex_state = 0, .external_lex_state = 2},
  [50] = {.lex_state = 0, .external_lex_state = 2},
  [51] = {.lex_state = 0, .external_lex_state = 2},
  [52] = {.lex_state = 0, .external_lex_state = 2},
  [53] = {.lex_state = 8, .external_lex_state = 3},
  [54] = {.lex_state = 8, .external_lex_state = 3},
  [55] = {.lex_state = 8, .external_lex_state = 3},
  [56] = {.lex_state = 9, .external_lex_state = 3},
  [57] = {.lex_state = 0, .external_lex_state = 2},
  [58] = {.lex_state = 0, .external_lex_state = 2},
  [59] = {.lex_state = 8, .external_lex_state = 3},
  [60] = {.lex_state = 8, .external_lex_state = 3},
  [61] = {.lex_state = 8, .external_lex_state = 3},
  [62] = {.lex_state = 8, .external_lex_state = 3},
  [63] = {.lex_state = 8, .external_lex_state = 3},
  [64] = {.lex_state = 8, .external_lex_state = 3},
  [65] = {.lex_state = 8, .external_lex_state = 3},
  [66] = {.lex_state = 8, .external_lex_state = 3},
  [67] = {.lex_state = 8, .external_lex_state = 3},
  [68] = {.lex_state = 8, .external_lex_state = 3},
  [69] = {.lex_state = 8, .external_lex_state = 3},
  [70] = {.lex_state = 8, .external_lex_state = 3},
  [71] = {.lex_state = 8, .external_lex_state = 3},
  [72] = {.lex_state = 8, .external_lex_state = 3},
  [73] = {.lex_state = 8, .external_lex_state = 3},
  [74] = {.lex_state = 8, .external_lex_state = 3},
  [75] = {.lex_state = 8, .external_lex_state = 3},
  [76] = {.lex_state = 8, .external_lex_state = 3},
  [77] = {.lex_state = 8, .external_lex_state = 3},
  [78] = {.lex_state = 8, .external_lex_state = 3},
  [79] = {.lex_state = 8, .external_lex_state = 3},
  [80] = {.lex_state = 8, .external_lex_state = 3},
  [81] = {.lex_state = 8, .external_lex_state = 3},
  [82] = {.lex_state = 8, .external_lex_state = 3},
  [83] = {.lex_state = 8, .external_lex_state = 3},
  [84] = {.lex_state = 8, .external_lex_state = 3},
  [85] = {.lex_state = 8, .external_lex_state = 3},
  [86] = {.lex_state = 8, .external_lex_state = 3},
  [87] = {.lex_state = 8, .external_lex_state = 3},
  [88] = {.lex_state = 8, .external_lex_state = 3},
  [89] = {.lex_state = 8, .external_lex_state = 3},
  [90] = {.lex_state = 8, .external_lex_state = 3},
  [91] = {.lex_state = 8, .external_lex_state = 3},
  [92] = {.lex_state = 8, .external_lex_state = 3},
  [93] = {.lex_state = 8, .external_lex_state = 3},
  [94] = {.lex_state = 0, .external_lex_state = 2},
  [95] = {.lex_state = 0, .external_lex_state = 2},
  [96] = {.lex_state = 0, .external_lex_state = 2},
  [97] = {.lex_state = 0, .external_lex_state = 2},
  [98] = {.lex_state = 0, .external_lex_state = 2},
  [99] = {.lex_state = 9, .external_lex_state = 3},
  [100] = {.lex_state = 0, .external_lex_state = 2},
  [101] = {.lex_state = 0, .external_lex_state = 2},
  [102] = {.lex_state = 0, .external_lex_state = 2},
  [103] = {.lex_state = 0, .external_lex_state = 2},
  [104] = {.lex_state = 0, .external_lex_state = 2},
  [105] = {.lex_state = 0, .external_lex_state = 2},
  [106] = {.lex_state = 0, .external_lex_state = 2},
  [107] = {.lex_state = 0, .external_lex_state = 2},
  [108] = {.lex_state = 0, .external_lex_state = 2},
  [109] = {.lex_state = 0, .external_lex_state = 2},
  [110] = {.lex_state = 0, .external_lex_state = 2},
  [111] = {.lex_state = 0, .external_lex_state = 2},
  [112] = {.lex_state = 0, .external_lex_state = 2},
  [113] = {.lex_state = 0, .external_lex_state = 2},
  [114] = {.lex_state = 0, .external_lex_state = 2},
  [115] = {.lex_state = 0, .external_lex_state = 2},
  [116] = {.lex_state = 0, .external_lex_state = 2},
  [117] = {.lex_state = 0, .external_lex_state = 2},
  [118] = {.lex_state = 0, .external_lex_state = 2},
  [119] = {.lex_state = 0, .external_lex_state = 2},
  [120] = {.lex_state = 0, .external_lex_state = 2},
  [121] = {.lex_state = 0, .external_lex_state = 2},
  [122] = {.lex_state = 0, .external_lex_state = 2},
  [123] = {.lex_state = 0, .external_lex_state = 2},
  [124] = {.lex_state = 0, .external_lex_state = 2},
  [125] = {.lex_state = 0, .external_lex_state = 2},
  [126] = {.lex_state = 0, .external_lex_state = 2},
  [127] = {.lex_state = 0, .external_lex_state = 2},
  [128] = {.lex_state = 0, .external_lex_state = 2},
  [129] = {.lex_state = 0, .external_lex_state = 2},
  [130] = {.lex_state = 0, .external_lex_state = 2},
  [131] = {.lex_state = 0, .external_lex_state = 2},
  [132] = {.lex_state = 0, .external_lex_state = 2},
  [133] = {.lex_state = 0, .external_lex_state = 2},
  [134] = {.lex_state = 0, .external_lex_state = 2},
  [135] = {.lex_state = 0, .external_lex_state = 2},
  [136] = {.lex_state = 0, .external_lex_state = 2},
  [137] = {.lex_state = 0, .external_lex_state = 2},
  [138] = {.lex_state = 0, .external_lex_state = 2},
  [139] = {.lex_state = 0, .external_lex_state = 2},
  [140] = {.lex_state = 0, .external_lex_state = 2},
  [141] = {.lex_state = 0, .external_lex_state = 2},
  [142] = {.lex_state = 0, .external_lex_state = 2},
  [143] = {.lex_state = 0, .external_lex_state = 2},
  [144] = {.lex_state = 0, .external_lex_state = 2},
  [145] = {.lex_state = 0, .external_lex_state = 2},
  [146] = {.lex_state = 0, .external_lex_state = 2},
  [147] = {.lex_state = 8, .external_lex_state = 3},
  [148] = {.lex_state = 0, .external_lex_state = 2},
  [149] = {.lex_state = 0, .external_lex_state = 2},
  [150] = {.lex_state = 0, .external_lex_state = 2},
  [151] = {.lex_state = 0, .external_lex_state = 2},
  [152] = {.lex_state = 9, .external_lex_state = 3},
  [153] = {.lex_state = 9, .external_lex_state = 3},
  [154] = {.lex_state = 0, .external_lex_state = 2},
  [155] = {.lex_state = 9, .external_lex_state = 3},
  [156] = {.lex_state = 9, .external_lex_state = 3},
  [157] = {.lex_state = 0, .external_lex_state = 2},
  [158] = {.lex_state = 0, .external_lex_state = 2},
  [159] = {.lex_state = 0, .external_lex_state = 3},
  [160] = {.lex_state = 0, .external_lex_state = 2},
  [161] = {.lex_state = 0, .external_lex_state = 2},
  [162] = {.lex_state = 0, .external_lex_state = 2},
  [163] = {.lex_state = 0, .external_lex_state = 2},
  [164] = {.lex_state = 0, .external_lex_state = 2},
  [165] = {.lex_state = 0, .external_lex_state = 2},
  [166] = {.lex_state = 0, .external_lex_state = 2},
  [167] = {.lex_state = 0, .external_lex_state = 2},
  [168] = {.lex_state = 0, .external_lex_state = 2},
  [169] = {.lex_state = 0, .external_lex_state = 2},
  [170] = {.lex_state = 0, .external_lex_state = 2},
  [171] = {.lex_state = 0, .external_lex_state = 2},
  [172] = {.lex_state = 8, .external_lex_state = 2},
  [173] = {.lex_state = 0, .external_lex_state = 2},
  [174] = {.lex_state = 0, .external_lex_state = 2},
  [175] = {.lex_state = 0, .external_lex_state = 2},
  [176] = {.lex_state = 0, .external_lex_state = 2},
  [177] = {.lex_state = 0, .external_lex_state = 2},
  [178] = {.lex_state = 0, .external_lex_state = 2},
  [179] = {.lex_state = 0, .external_lex_state = 2},
  [180] = {.lex_state = 9, .external_lex_state = 2},
  [181] = {.lex_state = 9, .external_lex_state = 2},
  [182] = {.lex_state = 9, .external_lex_state = 2},
  [183] = {.lex_state = 9, .external_lex_state = 2},
  [184] = {.lex_state = 0, .external_lex_state = 2},
  [185] = {.lex_state = 0, .external_lex_state = 2},
  [186] = {.lex_state = 0, .external_lex_state = 2},
  [187] = {.lex_state = 0, .external_lex_state = 2},
  [188] = {.lex_state = 0, .external_lex_state = 2},
  [189] = {.lex_state = 0, .external_lex_state = 3},
  [190] = {.lex_state = 0, .external_lex_state = 2},
  [191] = {.lex_state = 0, .external_lex_state = 2},
  [192] = {.lex_state = 0, .external_lex_state = 2},
  [193] = {.lex_state = 0, .external_lex_state = 2},
  [194] = {.lex_state = 0, .external_lex_state = 4},
  [195] = {.lex_state = 8, .external_lex_state = 2},
  [196] = {.lex_state = 0, .external_lex_state = 4},
  [197] = {.lex_state = 8, .external_lex_state = 2},
  [198] = {.lex_state = 0, .external_lex_state = 5},
  [199] = {.lex_state = 0, .external_lex_state = 2},
  [200] = {.lex_state = 0, .external_lex_state = 2},
  [201] = {.lex_state = 0, .external_lex_state = 2},
  [202] = {.lex_state = 0, .external_lex_state = 2},
  [203] = {.lex_state = 0, .external_lex_state = 2},
  [204] = {.lex_state = 0, .external_lex_state = 2},
  [205] = {.lex_state = 0, .external_lex_state = 2},
  [206] = {.lex_state = 0, .external_lex_state = 2},
  [207] = {.lex_state = 0, .external_lex_state = 2},
  [208] = {.lex_state = 0, .external_lex_state = 6},
  [209] = {.lex_state = 0, .external_lex_state = 2},
  [210] = {.lex_state = 0, .external_lex_state = 2},
  [211] = {.lex_state = 0, .external_lex_state = 2},
  [212] = {.lex_state = 0, .external_lex_state = 2},
  [213] = {.lex_state = 0, .external_lex_state = 2},
  [214] = {.lex_state = 0, .external_lex_state = 2},
  [215] = {.lex_state = 0, .external_lex_state = 2},
  [216] = {.lex_state = 0, .external_lex_state = 2},
  [217] = {.lex_state = 0, .external_lex_state = 2},
  [218] = {.lex_state = 0, .external_lex_state = 2},
  [219] = {.lex_state = 8, .external_lex_state = 2},
  [220] = {.lex_state = 0, .external_lex_state = 2},
  [221] = {.lex_state = 0, .external_lex_state = 6},
  [222] = {.lex_state = 0, .external_lex_state = 2},
  [223] = {.lex_state = 0, .external_lex_state = 2},
  [224] = {.lex_state = 0, .external_lex_state = 2},
  [225] = {.lex_state = 0, .external_lex_state = 2},
  [226] = {.lex_state = 0, .external_lex_state = 2},
  [227] = {.lex_state = 0, .external_lex_state = 2},
  [228] = {.lex_state = 0, .external_lex_state = 2},
  [229] = {.lex_state = 0, .external_lex_state = 2},
  [230] = {.lex_state = 0, .external_lex_state = 2},
  [231] = {.lex_state = 0, .external_lex_state = 2},
  [232] = {.lex_state = 0, .external_lex_state = 2},
  [233] = {.lex_state = 57, .external_lex_state = 2},
  [234] = {.lex_state = 0, .external_lex_state = 2},
  [235] = {.lex_state = 0, .external_lex_state = 7},
  [236] = {.lex_state = 0, .external_lex_state = 2},
  [237] = {.lex_state = 0, .external_lex_state = 2},
  [238] = {.lex_state = 0, .external_lex_state = 2},
  [239] = {.lex_state = 0, .external_lex_state = 2},
  [240] = {.lex_state = 0, .external_lex_state = 2},
  [241] = {.lex_state = 0, .external_lex_state = 2},
  [242] = {(TSStateId)(-1)},
  [243] = {(TSStateId)(-1)},
  [244] = {(TSStateId)(-1)},
};

enum {
  ts_external_token__block_comment_start = 0,
  ts_external_token__block_comment_content = 1,
  ts_external_token__block_comment_end = 2,
  ts_external_token__string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token__string_end = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__block_comment_start] = sym__block_comment_start,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__block_comment_end] = sym__block_comment_end,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static const bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_comment_end] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__block_comment_start] = true,
  },
  [3] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [4] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [5] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_comment_end] = true,
  },
  [6] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__string_end] = true,
  },
  [7] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_end] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [sym__block_comment_start] = ACTIONS(5),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__block_comment_end] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_chunk] = STATE(238),
    [sym_statement] = STATE(125),
    [sym_return_statement] = STATE(237),
    [sym_empty_statement] = STATE(121),
    [sym_assignment_statement] = STATE(121),
    [sym__variable_assignment_varlist] = STATE(236),
    [sym_label_statement] = STATE(121),
    [sym_goto_statement] = STATE(121),
    [sym_do_statement] = STATE(121),
    [sym_while_statement] = STATE(121),
    [sym_repeat_statement] = STATE(121),
    [sym_if_statement] = STATE(121),
    [sym_for_statement] = STATE(121),
    [sym_declaration] = STATE(135),
    [sym_function_declaration] = STATE(139),
    [sym__local_function_declaration] = STATE(145),
    [sym_variable_declaration] = STATE(146),
    [sym__prefix_expression] = STATE(152),
    [sym_variable] = STATE(153),
    [sym_bracket_index_expression] = STATE(2),
    [sym_dot_index_expression] = STATE(2),
    [sym_function_call] = STATE(99),
    [sym_method_index_expression] = STATE(159),
    [sym_parenthesized_expression] = STATE(156),
    [sym_comment] = STATE(1),
    [aux_sym_chunk_repeat1] = STATE(51),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [sym_hash_bang_line] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_COLON_COLON] = ACTIONS(17),
    [sym_break_statement] = ACTIONS(19),
    [anon_sym_goto] = ACTIONS(21),
    [anon_sym_do] = ACTIONS(23),
    [anon_sym_while] = ACTIONS(25),
    [anon_sym_repeat] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_function] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [sym__block_comment_start] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(2), 1,
      sym_comment,
    ACTIONS(39), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(41), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [65] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(3), 1,
      sym_comment,
    ACTIONS(43), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(45), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [130] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(4), 1,
      sym_comment,
    ACTIONS(47), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(49), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [195] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(5), 1,
      sym_comment,
    ACTIONS(51), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(53), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [259] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(6), 1,
      sym_comment,
    ACTIONS(55), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(57), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [323] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(7), 1,
      sym_comment,
    ACTIONS(59), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(61), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [387] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(8), 1,
      sym_comment,
    ACTIONS(63), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(65), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [451] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(9), 1,
      sym_comment,
    ACTIONS(67), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(69), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [515] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(10), 1,
      sym_comment,
    ACTIONS(71), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(73), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [579] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(11), 1,
      sym_comment,
    ACTIONS(79), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(81), 4,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(75), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(77), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [647] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(12), 1,
      sym_comment,
    ACTIONS(83), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(85), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [711] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(13), 1,
      sym_comment,
    ACTIONS(87), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(89), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [775] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(14), 1,
      sym_comment,
    ACTIONS(91), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(93), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [839] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(15), 1,
      sym_comment,
    ACTIONS(95), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(97), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [903] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(16), 1,
      sym_comment,
    ACTIONS(99), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(101), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [962] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(17), 1,
      sym_comment,
    ACTIONS(103), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(105), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1021] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    STATE(18), 1,
      sym_comment,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(107), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(109), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      sym_identifier,
  [1092] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(121), 1,
      anon_sym_CARET,
    STATE(19), 1,
      sym_comment,
    ACTIONS(107), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(109), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1153] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(121), 1,
      anon_sym_CARET,
    STATE(20), 1,
      sym_comment,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(107), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DOT_DOT,
    ACTIONS(109), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      sym_identifier,
  [1218] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(121), 1,
      anon_sym_CARET,
    STATE(21), 1,
      sym_comment,
    ACTIONS(123), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(125), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1279] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    STATE(22), 1,
      sym_comment,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(107), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(109), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      sym_identifier,
  [1350] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    STATE(23), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(107), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(109), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      sym_identifier,
  [1423] = 13,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    STATE(24), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(107), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
    ACTIONS(109), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      sym_identifier,
  [1498] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    STATE(25), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(107), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
    ACTIONS(109), 20,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
  [1575] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    STATE(26), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(107), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(109), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
  [1658] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(139), 1,
      anon_sym_and,
    STATE(27), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(107), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(109), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      sym_identifier,
  [1743] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    STATE(28), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(107), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(109), 20,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
  [1822] = 39,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    ACTIONS(143), 1,
      anon_sym_end,
    ACTIONS(145), 1,
      anon_sym_elseif,
    ACTIONS(147), 1,
      anon_sym_else,
    STATE(29), 1,
      sym_comment,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(160), 1,
      sym__block,
    STATE(161), 1,
      aux_sym_if_statement_repeat1,
    STATE(170), 1,
      sym_return_statement,
    STATE(191), 1,
      sym_elseif_statement,
    STATE(222), 1,
      sym_else_statement,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [1949] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(30), 1,
      sym_comment,
    ACTIONS(149), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(151), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2008] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(31), 1,
      sym_comment,
    ACTIONS(55), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(57), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2067] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(121), 1,
      anon_sym_CARET,
    STATE(32), 1,
      sym_comment,
    ACTIONS(107), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(109), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2128] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(33), 1,
      sym_comment,
    ACTIONS(95), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(97), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2187] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(34), 1,
      sym_comment,
    ACTIONS(67), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(69), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2246] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(35), 1,
      sym_comment,
    ACTIONS(71), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(73), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2305] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(36), 1,
      sym_comment,
    ACTIONS(75), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(77), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2364] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(139), 1,
      anon_sym_and,
    ACTIONS(157), 1,
      anon_sym_COMMA,
    ACTIONS(159), 1,
      anon_sym_or,
    STATE(37), 1,
      sym_comment,
    STATE(115), 1,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(153), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(155), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [2452] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(161), 1,
      ts_builtin_sym_end,
    ACTIONS(163), 1,
      sym_identifier,
    ACTIONS(168), 1,
      anon_sym_SEMI,
    ACTIONS(171), 1,
      anon_sym_COLON_COLON,
    ACTIONS(174), 1,
      sym_break_statement,
    ACTIONS(177), 1,
      anon_sym_goto,
    ACTIONS(180), 1,
      anon_sym_do,
    ACTIONS(183), 1,
      anon_sym_while,
    ACTIONS(186), 1,
      anon_sym_repeat,
    ACTIONS(189), 1,
      anon_sym_if,
    ACTIONS(192), 1,
      anon_sym_for,
    ACTIONS(195), 1,
      anon_sym_function,
    ACTIONS(198), 1,
      anon_sym_local,
    ACTIONS(201), 1,
      anon_sym_LPAREN,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(38), 2,
      sym_comment,
      aux_sym_chunk_repeat1,
    ACTIONS(166), 5,
      anon_sym_return,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2560] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    STATE(39), 1,
      sym_comment,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(170), 1,
      sym_return_statement,
    STATE(178), 1,
      sym__block,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(204), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2674] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    STATE(38), 1,
      aux_sym_chunk_repeat1,
    STATE(40), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(173), 1,
      sym_return_statement,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(206), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2786] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(139), 1,
      anon_sym_and,
    ACTIONS(159), 1,
      anon_sym_or,
    STATE(41), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(208), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(210), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [2869] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    ACTIONS(212), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(42), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(170), 1,
      sym_return_statement,
    STATE(200), 1,
      sym__block,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2981] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    ACTIONS(214), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(43), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(170), 1,
      sym_return_statement,
    STATE(218), 1,
      sym__block,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3093] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(139), 1,
      anon_sym_and,
    ACTIONS(159), 1,
      anon_sym_or,
    STATE(44), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(216), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(218), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [3175] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    ACTIONS(220), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(45), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(170), 1,
      sym_return_statement,
    STATE(225), 1,
      sym__block,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3287] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    ACTIONS(222), 1,
      anon_sym_until,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(46), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(170), 1,
      sym_return_statement,
    STATE(224), 1,
      sym__block,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3399] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    ACTIONS(224), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(47), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(170), 1,
      sym_return_statement,
    STATE(232), 1,
      sym__block,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3511] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(139), 1,
      anon_sym_and,
    ACTIONS(159), 1,
      anon_sym_or,
    STATE(48), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(226), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(228), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [3593] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_return,
    ACTIONS(230), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(49), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(170), 1,
      sym_return_statement,
    STATE(217), 1,
      sym__block,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3705] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      ts_builtin_sym_end,
    STATE(38), 1,
      aux_sym_chunk_repeat1,
    STATE(50), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(209), 1,
      sym_return_statement,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3814] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(234), 1,
      ts_builtin_sym_end,
    STATE(38), 1,
      aux_sym_chunk_repeat1,
    STATE(51), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(231), 1,
      sym_return_statement,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3923] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(234), 1,
      ts_builtin_sym_end,
    STATE(50), 1,
      aux_sym_chunk_repeat1,
    STATE(52), 1,
      sym_comment,
    STATE(99), 1,
      sym_function_call,
    STATE(125), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(139), 1,
      sym_function_declaration,
    STATE(145), 1,
      sym__local_function_declaration,
    STATE(146), 1,
      sym_variable_declaration,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(153), 1,
      sym_variable,
    STATE(156), 1,
      sym_parenthesized_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(231), 1,
      sym_return_statement,
    STATE(236), 1,
      sym__variable_assignment_varlist,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(121), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [4032] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(236), 1,
      anon_sym_SEMI,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(53), 1,
      sym_comment,
    STATE(58), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(157), 1,
      sym__expression_list,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    ACTIONS(238), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4111] = 22,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(258), 1,
      anon_sym_RBRACE,
    STATE(54), 1,
      sym_comment,
    STATE(95), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(166), 1,
      sym_field,
    STATE(206), 1,
      sym__field_list,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4190] = 22,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(260), 1,
      anon_sym_RBRACE,
    STATE(55), 1,
      sym_comment,
    STATE(95), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(166), 1,
      sym_field,
    STATE(210), 1,
      sym__field_list,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4269] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(262), 1,
      anon_sym_EQ,
    STATE(56), 1,
      sym_comment,
    ACTIONS(41), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(39), 24,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
  [4316] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(266), 1,
      anon_sym_else,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    STATE(57), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(264), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [4388] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(274), 1,
      anon_sym_COMMA,
    ACTIONS(276), 1,
      anon_sym_else,
    STATE(58), 1,
      sym_comment,
    STATE(154), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(272), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [4464] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(278), 1,
      anon_sym_RBRACE,
    STATE(59), 1,
      sym_comment,
    STATE(95), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(187), 1,
      sym_field,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4540] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(236), 1,
      anon_sym_SEMI,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(280), 1,
      ts_builtin_sym_end,
    STATE(58), 1,
      sym_expression,
    STATE(60), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(157), 1,
      sym__expression_list,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4616] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(282), 1,
      anon_sym_RBRACE,
    STATE(61), 1,
      sym_comment,
    STATE(95), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(187), 1,
      sym_field,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4692] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    STATE(62), 1,
      sym_comment,
    STATE(95), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(187), 1,
      sym_field,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4765] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(37), 1,
      sym_expression,
    STATE(63), 1,
      sym_comment,
    STATE(128), 1,
      sym__variable_assignment_explist,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4835] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(58), 1,
      sym_expression,
    STATE(64), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(228), 1,
      sym__expression_list,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4905] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(37), 1,
      sym_expression,
    STATE(65), 1,
      sym_comment,
    STATE(129), 1,
      sym__variable_assignment_explist,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4975] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(284), 1,
      anon_sym_RPAREN,
    STATE(66), 1,
      sym_comment,
    STATE(97), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5045] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(21), 1,
      sym_expression,
    STATE(67), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5112] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(68), 1,
      sym_comment,
    STATE(101), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5179] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(69), 1,
      sym_comment,
    STATE(109), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5246] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(70), 1,
      sym_comment,
    STATE(103), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5313] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(71), 1,
      sym_comment,
    STATE(98), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5380] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(41), 1,
      sym_expression,
    STATE(72), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5447] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(23), 1,
      sym_expression,
    STATE(73), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5514] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(74), 1,
      sym_comment,
    STATE(104), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5581] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(75), 1,
      sym_comment,
    STATE(110), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5648] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(22), 1,
      sym_expression,
    STATE(76), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5715] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(24), 1,
      sym_expression,
    STATE(77), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5782] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(78), 1,
      sym_comment,
    STATE(108), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5849] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(79), 1,
      sym_comment,
    STATE(96), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5916] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(57), 1,
      sym_expression,
    STATE(80), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5983] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(25), 1,
      sym_expression,
    STATE(81), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6050] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(82), 1,
      sym_comment,
    STATE(112), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6117] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(26), 1,
      sym_expression,
    STATE(83), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6184] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(27), 1,
      sym_expression,
    STATE(84), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6251] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(28), 1,
      sym_expression,
    STATE(85), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6318] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(48), 1,
      sym_expression,
    STATE(86), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6385] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(20), 1,
      sym_expression,
    STATE(87), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6452] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(19), 1,
      sym_expression,
    STATE(88), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6519] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(89), 1,
      sym_comment,
    STATE(111), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6586] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(18), 1,
      sym_expression,
    STATE(90), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6653] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(32), 1,
      sym_expression,
    STATE(91), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6720] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(44), 1,
      sym_expression,
    STATE(92), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6787] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(93), 1,
      sym_comment,
    STATE(107), 1,
      sym_expression,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(159), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(11), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(36), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6854] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(290), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_LT,
    STATE(94), 1,
      sym_comment,
    STATE(102), 1,
      aux_sym__att_name_list_repeat1,
    STATE(113), 1,
      sym__attrib,
    ACTIONS(286), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(288), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [6900] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    STATE(95), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(294), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [6964] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    STATE(96), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(296), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7028] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(274), 1,
      anon_sym_COMMA,
    ACTIONS(298), 1,
      anon_sym_RPAREN,
    STATE(97), 1,
      sym_comment,
    STATE(192), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7096] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    STATE(98), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(300), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7160] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(79), 1,
      anon_sym_COLON,
    STATE(99), 1,
      sym_comment,
    ACTIONS(302), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(81), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(304), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7202] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(292), 1,
      anon_sym_LT,
    STATE(100), 1,
      sym_comment,
    STATE(117), 1,
      sym__attrib,
    ACTIONS(306), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(308), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7243] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(310), 1,
      anon_sym_COMMA,
    ACTIONS(312), 1,
      anon_sym_do,
    STATE(101), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7308] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(290), 1,
      anon_sym_COMMA,
    STATE(102), 1,
      sym_comment,
    STATE(105), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(314), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(316), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7348] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(318), 1,
      anon_sym_then,
    STATE(103), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7410] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(320), 1,
      anon_sym_then,
    STATE(104), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7472] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(326), 1,
      anon_sym_COMMA,
    STATE(105), 2,
      sym_comment,
      aux_sym__att_name_list_repeat1,
    ACTIONS(322), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(324), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7510] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(290), 1,
      anon_sym_COMMA,
    STATE(105), 1,
      aux_sym__att_name_list_repeat1,
    STATE(106), 1,
      sym_comment,
    ACTIONS(329), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(331), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7550] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(333), 1,
      anon_sym_COMMA,
    STATE(107), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7612] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(335), 1,
      anon_sym_do,
    STATE(108), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7674] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(337), 1,
      anon_sym_do,
    STATE(109), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7736] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(339), 1,
      anon_sym_RPAREN,
    STATE(110), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7798] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(341), 1,
      anon_sym_RBRACK,
    STATE(111), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7860] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(111), 1,
      anon_sym_PLUS,
    ACTIONS(113), 1,
      anon_sym_DASH,
    ACTIONS(117), 1,
      anon_sym_SLASH,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_CARET,
    ACTIONS(129), 1,
      anon_sym_AMP,
    ACTIONS(131), 1,
      anon_sym_TILDE,
    ACTIONS(137), 1,
      anon_sym_PIPE,
    ACTIONS(268), 1,
      anon_sym_or,
    ACTIONS(270), 1,
      anon_sym_and,
    ACTIONS(343), 1,
      anon_sym_RBRACK,
    STATE(112), 1,
      sym_comment,
    ACTIONS(127), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(133), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(115), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(135), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7922] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(290), 1,
      anon_sym_COMMA,
    STATE(106), 1,
      aux_sym__att_name_list_repeat1,
    STATE(113), 1,
      sym_comment,
    ACTIONS(345), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(347), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7962] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(353), 1,
      anon_sym_COMMA,
    STATE(114), 2,
      sym_comment,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(349), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(351), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7999] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(157), 1,
      anon_sym_COMMA,
    STATE(114), 1,
      aux_sym__variable_assignment_explist_repeat1,
    STATE(115), 1,
      sym_comment,
    ACTIONS(356), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(358), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8038] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(116), 1,
      sym_comment,
    ACTIONS(360), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(362), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8073] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(117), 1,
      sym_comment,
    ACTIONS(364), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(366), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8108] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(372), 1,
      anon_sym_EQ,
    STATE(118), 1,
      sym_comment,
    ACTIONS(368), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(370), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8144] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(119), 1,
      sym_comment,
    ACTIONS(374), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(376), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8177] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(120), 1,
      sym_comment,
    ACTIONS(378), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(380), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8210] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(121), 1,
      sym_comment,
    ACTIONS(302), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(304), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8243] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(122), 1,
      sym_comment,
    ACTIONS(382), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(384), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8276] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(123), 1,
      sym_comment,
    ACTIONS(386), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(388), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8309] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(124), 1,
      sym_comment,
    ACTIONS(390), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(392), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8342] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(125), 1,
      sym_comment,
    ACTIONS(394), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(396), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8375] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(126), 1,
      sym_comment,
    ACTIONS(398), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(400), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8408] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(127), 1,
      sym_comment,
    ACTIONS(402), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(404), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8441] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(128), 1,
      sym_comment,
    ACTIONS(406), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(408), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8474] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(129), 1,
      sym_comment,
    ACTIONS(410), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(412), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8507] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(130), 1,
      sym_comment,
    ACTIONS(414), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(416), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8540] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(131), 1,
      sym_comment,
    ACTIONS(418), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(420), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8573] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(132), 1,
      sym_comment,
    ACTIONS(422), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(424), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8606] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(133), 1,
      sym_comment,
    ACTIONS(426), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(428), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8639] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(134), 1,
      sym_comment,
    ACTIONS(430), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(432), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8672] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(135), 1,
      sym_comment,
    ACTIONS(434), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(436), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8705] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(136), 1,
      sym_comment,
    ACTIONS(438), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(440), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8738] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(137), 1,
      sym_comment,
    ACTIONS(442), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(444), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8771] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(138), 1,
      sym_comment,
    ACTIONS(446), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(448), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8804] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(139), 1,
      sym_comment,
    ACTIONS(450), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(452), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8837] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(140), 1,
      sym_comment,
    ACTIONS(454), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(456), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8870] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(141), 1,
      sym_comment,
    ACTIONS(458), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(460), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8903] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(142), 1,
      sym_comment,
    ACTIONS(462), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(464), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8936] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(143), 1,
      sym_comment,
    ACTIONS(466), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(468), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8969] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(144), 1,
      sym_comment,
    ACTIONS(470), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(472), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [9002] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(145), 1,
      sym_comment,
    ACTIONS(474), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(476), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [9035] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(146), 1,
      sym_comment,
    ACTIONS(478), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(480), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [9068] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(147), 1,
      sym_comment,
    ACTIONS(482), 7,
      anon_sym_function,
      sym_nil,
      sym_false,
      sym_true,
      anon_sym_DASH,
      anon_sym_not,
      sym_identifier,
    ACTIONS(484), 9,
      sym__string_start,
      sym_number,
      sym_vararg_expression,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_POUND,
  [9098] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(148), 1,
      sym_comment,
    ACTIONS(488), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(486), 12,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [9127] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(149), 1,
      sym_comment,
    ACTIONS(492), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(490), 12,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [9156] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(266), 1,
      anon_sym_else,
    ACTIONS(494), 1,
      anon_sym_COMMA,
    STATE(150), 2,
      sym_comment,
      aux_sym__expression_list_repeat1,
    ACTIONS(264), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [9182] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(497), 1,
      sym_identifier,
    STATE(151), 1,
      sym_comment,
    STATE(152), 1,
      sym__prefix_expression,
    STATE(155), 1,
      sym_variable,
    STATE(159), 1,
      sym_method_index_expression,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(156), 2,
      sym_function_call,
      sym_parenthesized_expression,
  [9215] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(499), 1,
      anon_sym_DOT,
    ACTIONS(501), 1,
      anon_sym_COLON,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(505), 1,
      anon_sym_LBRACK,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(509), 1,
      sym__string_start,
    STATE(5), 1,
      sym_arguments,
    STATE(152), 1,
      sym_comment,
    STATE(7), 2,
      sym_string,
      sym_table_constructor,
  [9250] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(511), 1,
      anon_sym_EQ,
    ACTIONS(513), 1,
      anon_sym_COMMA,
    STATE(153), 1,
      sym_comment,
    STATE(184), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(81), 6,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [9277] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COMMA,
    ACTIONS(517), 1,
      anon_sym_else,
    STATE(150), 1,
      aux_sym__expression_list_repeat1,
    STATE(154), 1,
      sym_comment,
    ACTIONS(515), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9304] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(155), 1,
      sym_comment,
    ACTIONS(519), 2,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(81), 6,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [9326] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(156), 1,
      sym_comment,
    ACTIONS(81), 6,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [9344] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(523), 1,
      anon_sym_SEMI,
    ACTIONS(525), 1,
      anon_sym_else,
    STATE(157), 1,
      sym_comment,
    ACTIONS(521), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9366] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(147), 1,
      anon_sym_else,
    ACTIONS(527), 1,
      anon_sym_end,
    ACTIONS(529), 1,
      anon_sym_elseif,
    STATE(158), 1,
      sym_comment,
    STATE(163), 1,
      aux_sym_if_statement_repeat1,
    STATE(191), 1,
      sym_elseif_statement,
    STATE(227), 1,
      sym_else_statement,
  [9394] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(503), 1,
      anon_sym_LPAREN,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(509), 1,
      sym__string_start,
    STATE(5), 1,
      sym_arguments,
    STATE(159), 1,
      sym_comment,
    STATE(7), 2,
      sym_string,
      sym_table_constructor,
  [9420] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(147), 1,
      anon_sym_else,
    ACTIONS(529), 1,
      anon_sym_elseif,
    ACTIONS(531), 1,
      anon_sym_end,
    STATE(158), 1,
      aux_sym_if_statement_repeat1,
    STATE(160), 1,
      sym_comment,
    STATE(191), 1,
      sym_elseif_statement,
    STATE(207), 1,
      sym_else_statement,
  [9448] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(147), 1,
      anon_sym_else,
    ACTIONS(529), 1,
      anon_sym_elseif,
    ACTIONS(533), 1,
      anon_sym_end,
    STATE(161), 1,
      sym_comment,
    STATE(163), 1,
      aux_sym_if_statement_repeat1,
    STATE(191), 1,
      sym_elseif_statement,
    STATE(211), 1,
      sym_else_statement,
  [9476] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(282), 1,
      anon_sym_RBRACE,
    STATE(59), 1,
      sym__field_sep,
    STATE(162), 1,
      sym_comment,
    STATE(168), 1,
      aux_sym__field_list_repeat1,
    ACTIONS(535), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [9499] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(537), 1,
      anon_sym_end,
    ACTIONS(539), 1,
      anon_sym_elseif,
    ACTIONS(542), 1,
      anon_sym_else,
    STATE(191), 1,
      sym_elseif_statement,
    STATE(163), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [9522] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(546), 1,
      anon_sym_else,
    STATE(164), 1,
      sym_comment,
    ACTIONS(544), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9541] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(525), 1,
      anon_sym_else,
    STATE(165), 1,
      sym_comment,
    ACTIONS(521), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9560] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      anon_sym_RBRACE,
    STATE(61), 1,
      sym__field_sep,
    STATE(162), 1,
      aux_sym__field_list_repeat1,
    STATE(166), 1,
      sym_comment,
    ACTIONS(535), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [9583] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(550), 1,
      sym_identifier,
    STATE(167), 1,
      sym_comment,
    STATE(176), 1,
      sym__function_name,
    STATE(182), 1,
      sym__function_name_prefix_expression,
    STATE(183), 1,
      sym__function_name_dot_index_expression,
    STATE(216), 1,
      sym__function_name_method_index_expression,
  [9608] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(555), 1,
      anon_sym_RBRACE,
    STATE(62), 1,
      sym__field_sep,
    ACTIONS(552), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(168), 2,
      sym_comment,
      aux_sym__field_list_repeat1,
  [9629] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(560), 2,
      anon_sym_in,
      anon_sym_RPAREN,
    STATE(169), 2,
      sym_comment,
      aux_sym__name_list_repeat1,
  [9647] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(206), 1,
      anon_sym_else,
    STATE(170), 1,
      sym_comment,
    ACTIONS(562), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9665] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(564), 1,
      sym_identifier,
    ACTIONS(566), 1,
      anon_sym_function,
    STATE(118), 1,
      sym__att_name_list,
    STATE(134), 1,
      sym__local_variable_assignment,
    STATE(171), 1,
      sym_comment,
  [9687] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(568), 1,
      sym_identifier,
    ACTIONS(570), 1,
      sym_vararg_expression,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    STATE(172), 1,
      sym_comment,
    STATE(229), 1,
      sym__parameter_list,
  [9709] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(576), 1,
      anon_sym_else,
    STATE(173), 1,
      sym_comment,
    ACTIONS(574), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9727] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      sym_identifier,
    STATE(174), 1,
      sym_comment,
    STATE(205), 1,
      sym__name_list,
    STATE(234), 2,
      sym_for_generic_clause,
      sym_for_numeric_clause,
  [9747] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(580), 1,
      anon_sym_EQ,
    ACTIONS(582), 1,
      anon_sym_COMMA,
    ACTIONS(584), 1,
      anon_sym_in,
    STATE(175), 1,
      sym_comment,
    STATE(193), 1,
      aux_sym__name_list_repeat1,
  [9769] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(586), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parameters,
    STATE(124), 1,
      sym__function_body,
    STATE(176), 1,
      sym_comment,
  [9788] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(177), 1,
      sym_comment,
    ACTIONS(588), 3,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_RPAREN,
  [9803] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(592), 1,
      anon_sym_else,
    STATE(178), 1,
      sym_comment,
    ACTIONS(590), 2,
      anon_sym_end,
      anon_sym_elseif,
  [9820] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(586), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym__function_body,
    STATE(43), 1,
      sym_parameters,
    STATE(179), 1,
      sym_comment,
  [9839] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(180), 1,
      sym_comment,
    ACTIONS(594), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [9854] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(181), 1,
      sym_comment,
    ACTIONS(596), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [9869] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(598), 1,
      anon_sym_DOT,
    ACTIONS(600), 1,
      anon_sym_COLON,
    ACTIONS(602), 1,
      anon_sym_LPAREN,
    STATE(182), 1,
      sym_comment,
  [9888] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(183), 1,
      sym_comment,
    ACTIONS(604), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [9903] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(513), 1,
      anon_sym_COMMA,
    ACTIONS(606), 1,
      anon_sym_EQ,
    STATE(184), 1,
      sym_comment,
    STATE(188), 1,
      aux_sym__variable_assignment_varlist_repeat1,
  [9922] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(608), 1,
      anon_sym_COMMA,
    ACTIONS(610), 1,
      anon_sym_RPAREN,
    STATE(169), 1,
      aux_sym__name_list_repeat1,
    STATE(185), 1,
      sym_comment,
  [9941] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(586), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parameters,
    STATE(138), 1,
      sym__function_body,
    STATE(186), 1,
      sym_comment,
  [9960] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(187), 1,
      sym_comment,
    ACTIONS(555), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [9975] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(612), 1,
      anon_sym_EQ,
    ACTIONS(614), 1,
      anon_sym_COMMA,
    STATE(188), 2,
      sym_comment,
      aux_sym__variable_assignment_varlist_repeat1,
  [9992] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(189), 1,
      sym_comment,
    ACTIONS(617), 3,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [10007] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(619), 1,
      anon_sym_COMMA,
    ACTIONS(621), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      aux_sym__name_list_repeat1,
    STATE(190), 1,
      sym_comment,
  [10026] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(625), 1,
      anon_sym_else,
    STATE(191), 1,
      sym_comment,
    ACTIONS(623), 2,
      anon_sym_end,
      anon_sym_elseif,
  [10043] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COMMA,
    ACTIONS(627), 1,
      anon_sym_RPAREN,
    STATE(150), 1,
      aux_sym__expression_list_repeat1,
    STATE(192), 1,
      sym_comment,
  [10062] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(582), 1,
      anon_sym_COMMA,
    ACTIONS(629), 1,
      anon_sym_in,
    STATE(169), 1,
      aux_sym__name_list_repeat1,
    STATE(193), 1,
      sym_comment,
  [10081] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(631), 1,
      sym__string_content,
    ACTIONS(633), 1,
      sym__string_end,
    STATE(194), 1,
      sym_comment,
  [10097] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(635), 1,
      sym_identifier,
    ACTIONS(637), 1,
      sym_vararg_expression,
    STATE(195), 1,
      sym_comment,
  [10113] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(639), 1,
      sym__string_content,
    ACTIONS(641), 1,
      sym__string_end,
    STATE(196), 1,
      sym_comment,
  [10129] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(635), 1,
      sym_identifier,
    ACTIONS(643), 1,
      sym_vararg_expression,
    STATE(197), 1,
      sym_comment,
  [10145] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(645), 1,
      sym__block_comment_content,
    ACTIONS(647), 1,
      sym__block_comment_end,
    STATE(198), 1,
      sym_comment,
  [10161] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(649), 1,
      anon_sym_LPAREN,
    STATE(199), 1,
      sym_comment,
  [10174] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(651), 1,
      anon_sym_end,
    STATE(200), 1,
      sym_comment,
  [10187] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(653), 1,
      sym_identifier,
    STATE(201), 1,
      sym_comment,
  [10200] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(655), 1,
      anon_sym_EQ,
    STATE(202), 1,
      sym_comment,
  [10213] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(657), 1,
      sym_identifier,
    STATE(203), 1,
      sym_comment,
  [10226] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(635), 1,
      sym_identifier,
    STATE(204), 1,
      sym_comment,
  [10239] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(659), 1,
      anon_sym_in,
    STATE(205), 1,
      sym_comment,
  [10252] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(661), 1,
      anon_sym_RBRACE,
    STATE(206), 1,
      sym_comment,
  [10265] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(663), 1,
      anon_sym_end,
    STATE(207), 1,
      sym_comment,
  [10278] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(665), 1,
      sym__string_end,
    STATE(208), 1,
      sym_comment,
  [10291] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(667), 1,
      ts_builtin_sym_end,
    STATE(209), 1,
      sym_comment,
  [10304] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(669), 1,
      anon_sym_RBRACE,
    STATE(210), 1,
      sym_comment,
  [10317] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(671), 1,
      anon_sym_end,
    STATE(211), 1,
      sym_comment,
  [10330] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(673), 1,
      sym_identifier,
    STATE(212), 1,
      sym_comment,
  [10343] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(675), 1,
      sym_identifier,
    STATE(213), 1,
      sym_comment,
  [10356] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(677), 1,
      sym_identifier,
    STATE(214), 1,
      sym_comment,
  [10369] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(679), 1,
      sym_identifier,
    STATE(215), 1,
      sym_comment,
  [10382] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    STATE(216), 1,
      sym_comment,
  [10395] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(683), 1,
      anon_sym_end,
    STATE(217), 1,
      sym_comment,
  [10408] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(685), 1,
      anon_sym_end,
    STATE(218), 1,
      sym_comment,
  [10421] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(687), 1,
      anon_sym_GT,
    STATE(219), 1,
      sym_comment,
  [10434] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(689), 1,
      anon_sym_RPAREN,
    STATE(220), 1,
      sym_comment,
  [10447] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(691), 1,
      sym__string_end,
    STATE(221), 1,
      sym_comment,
  [10460] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(693), 1,
      anon_sym_end,
    STATE(222), 1,
      sym_comment,
  [10473] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(695), 1,
      sym_identifier,
    STATE(223), 1,
      sym_comment,
  [10486] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(697), 1,
      anon_sym_until,
    STATE(224), 1,
      sym_comment,
  [10499] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(699), 1,
      anon_sym_end,
    STATE(225), 1,
      sym_comment,
  [10512] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(701), 1,
      anon_sym_COLON_COLON,
    STATE(226), 1,
      sym_comment,
  [10525] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(703), 1,
      anon_sym_end,
    STATE(227), 1,
      sym_comment,
  [10538] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(705), 1,
      anon_sym_do,
    STATE(228), 1,
      sym_comment,
  [10551] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(707), 1,
      anon_sym_RPAREN,
    STATE(229), 1,
      sym_comment,
  [10564] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(709), 1,
      anon_sym_RPAREN,
    STATE(230), 1,
      sym_comment,
  [10577] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(232), 1,
      ts_builtin_sym_end,
    STATE(231), 1,
      sym_comment,
  [10590] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(711), 1,
      anon_sym_end,
    STATE(232), 1,
      sym_comment,
  [10603] = 4,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(713), 1,
      anon_sym_DASH_DASH,
    ACTIONS(715), 1,
      aux_sym_comment_token1,
    STATE(233), 1,
      sym_comment,
  [10616] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(717), 1,
      anon_sym_do,
    STATE(234), 1,
      sym_comment,
  [10629] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(719), 1,
      sym__block_comment_end,
    STATE(235), 1,
      sym_comment,
  [10642] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(721), 1,
      anon_sym_EQ,
    STATE(236), 1,
      sym_comment,
  [10655] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(234), 1,
      ts_builtin_sym_end,
    STATE(237), 1,
      sym_comment,
  [10668] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(723), 1,
      ts_builtin_sym_end,
    STATE(238), 1,
      sym_comment,
  [10681] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(725), 1,
      sym_identifier,
    STATE(239), 1,
      sym_comment,
  [10694] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(727), 1,
      sym_identifier,
    STATE(240), 1,
      sym_comment,
  [10707] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(729), 1,
      anon_sym_RPAREN,
    STATE(241), 1,
      sym_comment,
  [10720] = 1,
    ACTIONS(731), 1,
      ts_builtin_sym_end,
  [10724] = 1,
    ACTIONS(733), 1,
      ts_builtin_sym_end,
  [10728] = 1,
    ACTIONS(735), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 65,
  [SMALL_STATE(4)] = 130,
  [SMALL_STATE(5)] = 195,
  [SMALL_STATE(6)] = 259,
  [SMALL_STATE(7)] = 323,
  [SMALL_STATE(8)] = 387,
  [SMALL_STATE(9)] = 451,
  [SMALL_STATE(10)] = 515,
  [SMALL_STATE(11)] = 579,
  [SMALL_STATE(12)] = 647,
  [SMALL_STATE(13)] = 711,
  [SMALL_STATE(14)] = 775,
  [SMALL_STATE(15)] = 839,
  [SMALL_STATE(16)] = 903,
  [SMALL_STATE(17)] = 962,
  [SMALL_STATE(18)] = 1021,
  [SMALL_STATE(19)] = 1092,
  [SMALL_STATE(20)] = 1153,
  [SMALL_STATE(21)] = 1218,
  [SMALL_STATE(22)] = 1279,
  [SMALL_STATE(23)] = 1350,
  [SMALL_STATE(24)] = 1423,
  [SMALL_STATE(25)] = 1498,
  [SMALL_STATE(26)] = 1575,
  [SMALL_STATE(27)] = 1658,
  [SMALL_STATE(28)] = 1743,
  [SMALL_STATE(29)] = 1822,
  [SMALL_STATE(30)] = 1949,
  [SMALL_STATE(31)] = 2008,
  [SMALL_STATE(32)] = 2067,
  [SMALL_STATE(33)] = 2128,
  [SMALL_STATE(34)] = 2187,
  [SMALL_STATE(35)] = 2246,
  [SMALL_STATE(36)] = 2305,
  [SMALL_STATE(37)] = 2364,
  [SMALL_STATE(38)] = 2452,
  [SMALL_STATE(39)] = 2560,
  [SMALL_STATE(40)] = 2674,
  [SMALL_STATE(41)] = 2786,
  [SMALL_STATE(42)] = 2869,
  [SMALL_STATE(43)] = 2981,
  [SMALL_STATE(44)] = 3093,
  [SMALL_STATE(45)] = 3175,
  [SMALL_STATE(46)] = 3287,
  [SMALL_STATE(47)] = 3399,
  [SMALL_STATE(48)] = 3511,
  [SMALL_STATE(49)] = 3593,
  [SMALL_STATE(50)] = 3705,
  [SMALL_STATE(51)] = 3814,
  [SMALL_STATE(52)] = 3923,
  [SMALL_STATE(53)] = 4032,
  [SMALL_STATE(54)] = 4111,
  [SMALL_STATE(55)] = 4190,
  [SMALL_STATE(56)] = 4269,
  [SMALL_STATE(57)] = 4316,
  [SMALL_STATE(58)] = 4388,
  [SMALL_STATE(59)] = 4464,
  [SMALL_STATE(60)] = 4540,
  [SMALL_STATE(61)] = 4616,
  [SMALL_STATE(62)] = 4692,
  [SMALL_STATE(63)] = 4765,
  [SMALL_STATE(64)] = 4835,
  [SMALL_STATE(65)] = 4905,
  [SMALL_STATE(66)] = 4975,
  [SMALL_STATE(67)] = 5045,
  [SMALL_STATE(68)] = 5112,
  [SMALL_STATE(69)] = 5179,
  [SMALL_STATE(70)] = 5246,
  [SMALL_STATE(71)] = 5313,
  [SMALL_STATE(72)] = 5380,
  [SMALL_STATE(73)] = 5447,
  [SMALL_STATE(74)] = 5514,
  [SMALL_STATE(75)] = 5581,
  [SMALL_STATE(76)] = 5648,
  [SMALL_STATE(77)] = 5715,
  [SMALL_STATE(78)] = 5782,
  [SMALL_STATE(79)] = 5849,
  [SMALL_STATE(80)] = 5916,
  [SMALL_STATE(81)] = 5983,
  [SMALL_STATE(82)] = 6050,
  [SMALL_STATE(83)] = 6117,
  [SMALL_STATE(84)] = 6184,
  [SMALL_STATE(85)] = 6251,
  [SMALL_STATE(86)] = 6318,
  [SMALL_STATE(87)] = 6385,
  [SMALL_STATE(88)] = 6452,
  [SMALL_STATE(89)] = 6519,
  [SMALL_STATE(90)] = 6586,
  [SMALL_STATE(91)] = 6653,
  [SMALL_STATE(92)] = 6720,
  [SMALL_STATE(93)] = 6787,
  [SMALL_STATE(94)] = 6854,
  [SMALL_STATE(95)] = 6900,
  [SMALL_STATE(96)] = 6964,
  [SMALL_STATE(97)] = 7028,
  [SMALL_STATE(98)] = 7096,
  [SMALL_STATE(99)] = 7160,
  [SMALL_STATE(100)] = 7202,
  [SMALL_STATE(101)] = 7243,
  [SMALL_STATE(102)] = 7308,
  [SMALL_STATE(103)] = 7348,
  [SMALL_STATE(104)] = 7410,
  [SMALL_STATE(105)] = 7472,
  [SMALL_STATE(106)] = 7510,
  [SMALL_STATE(107)] = 7550,
  [SMALL_STATE(108)] = 7612,
  [SMALL_STATE(109)] = 7674,
  [SMALL_STATE(110)] = 7736,
  [SMALL_STATE(111)] = 7798,
  [SMALL_STATE(112)] = 7860,
  [SMALL_STATE(113)] = 7922,
  [SMALL_STATE(114)] = 7962,
  [SMALL_STATE(115)] = 7999,
  [SMALL_STATE(116)] = 8038,
  [SMALL_STATE(117)] = 8073,
  [SMALL_STATE(118)] = 8108,
  [SMALL_STATE(119)] = 8144,
  [SMALL_STATE(120)] = 8177,
  [SMALL_STATE(121)] = 8210,
  [SMALL_STATE(122)] = 8243,
  [SMALL_STATE(123)] = 8276,
  [SMALL_STATE(124)] = 8309,
  [SMALL_STATE(125)] = 8342,
  [SMALL_STATE(126)] = 8375,
  [SMALL_STATE(127)] = 8408,
  [SMALL_STATE(128)] = 8441,
  [SMALL_STATE(129)] = 8474,
  [SMALL_STATE(130)] = 8507,
  [SMALL_STATE(131)] = 8540,
  [SMALL_STATE(132)] = 8573,
  [SMALL_STATE(133)] = 8606,
  [SMALL_STATE(134)] = 8639,
  [SMALL_STATE(135)] = 8672,
  [SMALL_STATE(136)] = 8705,
  [SMALL_STATE(137)] = 8738,
  [SMALL_STATE(138)] = 8771,
  [SMALL_STATE(139)] = 8804,
  [SMALL_STATE(140)] = 8837,
  [SMALL_STATE(141)] = 8870,
  [SMALL_STATE(142)] = 8903,
  [SMALL_STATE(143)] = 8936,
  [SMALL_STATE(144)] = 8969,
  [SMALL_STATE(145)] = 9002,
  [SMALL_STATE(146)] = 9035,
  [SMALL_STATE(147)] = 9068,
  [SMALL_STATE(148)] = 9098,
  [SMALL_STATE(149)] = 9127,
  [SMALL_STATE(150)] = 9156,
  [SMALL_STATE(151)] = 9182,
  [SMALL_STATE(152)] = 9215,
  [SMALL_STATE(153)] = 9250,
  [SMALL_STATE(154)] = 9277,
  [SMALL_STATE(155)] = 9304,
  [SMALL_STATE(156)] = 9326,
  [SMALL_STATE(157)] = 9344,
  [SMALL_STATE(158)] = 9366,
  [SMALL_STATE(159)] = 9394,
  [SMALL_STATE(160)] = 9420,
  [SMALL_STATE(161)] = 9448,
  [SMALL_STATE(162)] = 9476,
  [SMALL_STATE(163)] = 9499,
  [SMALL_STATE(164)] = 9522,
  [SMALL_STATE(165)] = 9541,
  [SMALL_STATE(166)] = 9560,
  [SMALL_STATE(167)] = 9583,
  [SMALL_STATE(168)] = 9608,
  [SMALL_STATE(169)] = 9629,
  [SMALL_STATE(170)] = 9647,
  [SMALL_STATE(171)] = 9665,
  [SMALL_STATE(172)] = 9687,
  [SMALL_STATE(173)] = 9709,
  [SMALL_STATE(174)] = 9727,
  [SMALL_STATE(175)] = 9747,
  [SMALL_STATE(176)] = 9769,
  [SMALL_STATE(177)] = 9788,
  [SMALL_STATE(178)] = 9803,
  [SMALL_STATE(179)] = 9820,
  [SMALL_STATE(180)] = 9839,
  [SMALL_STATE(181)] = 9854,
  [SMALL_STATE(182)] = 9869,
  [SMALL_STATE(183)] = 9888,
  [SMALL_STATE(184)] = 9903,
  [SMALL_STATE(185)] = 9922,
  [SMALL_STATE(186)] = 9941,
  [SMALL_STATE(187)] = 9960,
  [SMALL_STATE(188)] = 9975,
  [SMALL_STATE(189)] = 9992,
  [SMALL_STATE(190)] = 10007,
  [SMALL_STATE(191)] = 10026,
  [SMALL_STATE(192)] = 10043,
  [SMALL_STATE(193)] = 10062,
  [SMALL_STATE(194)] = 10081,
  [SMALL_STATE(195)] = 10097,
  [SMALL_STATE(196)] = 10113,
  [SMALL_STATE(197)] = 10129,
  [SMALL_STATE(198)] = 10145,
  [SMALL_STATE(199)] = 10161,
  [SMALL_STATE(200)] = 10174,
  [SMALL_STATE(201)] = 10187,
  [SMALL_STATE(202)] = 10200,
  [SMALL_STATE(203)] = 10213,
  [SMALL_STATE(204)] = 10226,
  [SMALL_STATE(205)] = 10239,
  [SMALL_STATE(206)] = 10252,
  [SMALL_STATE(207)] = 10265,
  [SMALL_STATE(208)] = 10278,
  [SMALL_STATE(209)] = 10291,
  [SMALL_STATE(210)] = 10304,
  [SMALL_STATE(211)] = 10317,
  [SMALL_STATE(212)] = 10330,
  [SMALL_STATE(213)] = 10343,
  [SMALL_STATE(214)] = 10356,
  [SMALL_STATE(215)] = 10369,
  [SMALL_STATE(216)] = 10382,
  [SMALL_STATE(217)] = 10395,
  [SMALL_STATE(218)] = 10408,
  [SMALL_STATE(219)] = 10421,
  [SMALL_STATE(220)] = 10434,
  [SMALL_STATE(221)] = 10447,
  [SMALL_STATE(222)] = 10460,
  [SMALL_STATE(223)] = 10473,
  [SMALL_STATE(224)] = 10486,
  [SMALL_STATE(225)] = 10499,
  [SMALL_STATE(226)] = 10512,
  [SMALL_STATE(227)] = 10525,
  [SMALL_STATE(228)] = 10538,
  [SMALL_STATE(229)] = 10551,
  [SMALL_STATE(230)] = 10564,
  [SMALL_STATE(231)] = 10577,
  [SMALL_STATE(232)] = 10590,
  [SMALL_STATE(233)] = 10603,
  [SMALL_STATE(234)] = 10616,
  [SMALL_STATE(235)] = 10629,
  [SMALL_STATE(236)] = 10642,
  [SMALL_STATE(237)] = 10655,
  [SMALL_STATE(238)] = 10668,
  [SMALL_STATE(239)] = 10681,
  [SMALL_STATE(240)] = 10694,
  [SMALL_STATE(241)] = 10707,
  [SMALL_STATE(242)] = 10720,
  [SMALL_STATE(243)] = 10724,
  [SMALL_STATE(244)] = 10728,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracket_index_expression, 4, .production_id = 22),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracket_index_expression, 4, .production_id = 22),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_index_expression, 3, .production_id = 22),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_index_expression, 3, .production_id = 22),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, .production_id = 10),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, .production_id = 10),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 3),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 3),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 1),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 1),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, .production_id = 12),
  [69] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, .production_id = 12),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 2),
  [73] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 2),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [79] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression, 1),
  [81] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression, 1),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [85] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [89] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [93] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, .production_id = 5),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, .production_id = 5),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, .production_id = 26),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, .production_id = 26),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, .production_id = 39),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, .production_id = 39),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 27),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 27),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 15),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 15),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, .production_id = 13),
  [151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, .production_id = 13),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 1, .production_id = 14),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 1, .production_id = 14),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(2),
  [166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(126),
  [171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(240),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(121),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(239),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(45),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(69),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(46),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(70),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(174),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(167),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(171),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(75),
  [204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 3, .production_id = 28),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 48),
  [210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 48),
  [212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 1),
  [214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 4, .production_id = 29),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 4, .production_id = 29),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, .production_id = 17),
  [228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, .production_id = 17),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 2),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 1),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2),
  [266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 1),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 1),
  [278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 3),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 2),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 1, .production_id = 4),
  [288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 1, .production_id = 4),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, .production_id = 14),
  [296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, .production_id = 40),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, .production_id = 54),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, .production_id = 24),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, .production_id = 24),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 5, .production_id = 53),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, .production_id = 20),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, .production_id = 20),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, .production_id = 35),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, .production_id = 35),
  [326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, .production_id = 35), SHIFT_REPEAT(223),
  [329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 3, .production_id = 34),
  [331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 3, .production_id = 34),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 7, .production_id = 56),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, .production_id = 19),
  [347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, .production_id = 19),
  [349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 49),
  [351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 49),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 49), SHIFT_REPEAT(72),
  [356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 2, .production_id = 37),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 2, .production_id = 37),
  [360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attrib, 3),
  [362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attrib, 3),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 3, .production_id = 47),
  [366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 3, .production_id = 47),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, .production_id = 9),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, .production_id = 9),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 46),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 46),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 41),
  [380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 41),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2),
  [384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2),
  [386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 50),
  [388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 50),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, .production_id = 18),
  [392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, .production_id = 18),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 1),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 1),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 51),
  [404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 51),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, .production_id = 21),
  [408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, .production_id = 21),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_variable_assignment, 3, .production_id = 36),
  [412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_variable_assignment, 3, .production_id = 36),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 52),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 52),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 44),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 44),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_statement, 3),
  [428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_statement, 3),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, .production_id = 1),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, .production_id = 1),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 55),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 55),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 3, .production_id = 16),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 3, .production_id = 16),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 4, .production_id = 33),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_function_declaration, 4, .production_id = 33),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, .production_id = 31),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, .production_id = 31),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 42),
  [460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 42),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 28),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 28),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 2),
  [468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 2),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 28),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 28),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, .production_id = 2),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, .production_id = 2),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, .production_id = 3),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, .production_id = 3),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_sep, 1),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_sep, 1),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, .production_id = 38),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, .production_id = 38),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2), SHIFT_REPEAT(80),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 1, .production_id = 4),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 2),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 2),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, .production_id = 24),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 45),
  [539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 45), SHIFT_REPEAT(74),
  [542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 45),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 1),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2), SHIFT_REPEAT(147),
  [555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2),
  [557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 25), SHIFT_REPEAT(204),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 25),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2),
  [576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 1, .production_id = 4),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 24),
  [590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_statement, 4, .production_id = 42),
  [592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 4, .production_id = 42),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_dot_index_expression, 3, .production_id = 22),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, .production_id = 7),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 2, .production_id = 11),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2, .production_id = 11),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, .production_id = 25),
  [614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, .production_id = 25), SHIFT_REPEAT(151),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_index_expression, 3, .production_id = 23),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 1, .production_id = 4),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 30),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 30),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 2, .production_id = 11),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_method_index_expression, 3, .production_id = 23),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2, .production_id = 16),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 3),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, .production_id = 8),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 3, .production_id = 4),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_generic_clause, 3, .production_id = 32),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 4, .production_id = 11),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [723] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 1),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, .production_id = 6),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, .production_id = 5),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 3, .production_id = 12),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_lua_external_scanner_create(void);
void tree_sitter_lua_external_scanner_destroy(void *);
bool tree_sitter_lua_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_lua_external_scanner_serialize(void *, char *);
void tree_sitter_lua_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_lua(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_lua_external_scanner_create,
      tree_sitter_lua_external_scanner_destroy,
      tree_sitter_lua_external_scanner_scan,
      tree_sitter_lua_external_scanner_serialize,
      tree_sitter_lua_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
